using GLMakie
GLMakie.activate!()
using dg1d


function plot_tree1d()

  t1d = Tree1d(5)
  xs = [ Float64(c[1]) for c in t1d.coords ]
  ys = zeros(length(xs))
  is_bdry = dg1d.is_boundarycell.(t1d.cells)
  bxs, bys = xs[is_bdry], ys[is_bdry]
  fig = Figure()
  scatterlines(fig[1,1], xs, ys)
  scatter!(fig[1,1], bxs, bys, color=:red)

  return fig
end


function plot_tree2d()

  t2d = Tree2d(10,10)
  xs_ys = [ t2d.coords[row][col] for row = 1:n_cells(t2d), col = 1:2 ]
  xs, ys = xs_ys[:,1], xs_ys[:,2]
  is_bdry = dg1d.is_boundarycell.(t2d.cells)
  bxs, bys = xs[is_bdry], ys[is_bdry]
  fig = Figure()
  scatterlines(fig[1,1], xs, ys)
  scatter!(fig[1,1], bxs, bys, color=:red)

  return fig
end


function plot_tree3d()

  t3d = Tree3d(10,10,10)
  xs_ys_zs = [ t3d.coords[row][col] for row = 1:n_cells(t3d), col = 1:3 ]
  xs, ys, zs = xs_ys_zs[:,1], xs_ys_zs[:,2], xs_ys_zs[:,3]
  is_bdry = dg1d.is_boundarycell.(t3d.cells)
  fig = Figure()
  scatterlines(fig[1,1], xs, ys, zs, markersize=100)
  bxs, bys, bzs = xs[is_bdry], ys[is_bdry], zs[is_bdry]
  scatter!(fig[1,1], bxs, bys, bzs, color=:red, markersize=200)

  return fig
end
